/*
 * ARISTOSTLE UNIVERSITY OF THESSALONIKI
 * Copyright (C) 2015
 * Aristotle University of Thessaloniki
 * Department of Electrical & Computer Engineering
 * Division of Electronics & Computer Engineering
 * Intelligent Systems & Software Engineering Lab
 *
 * Project             : WSAT
 * WorkFile            : 
 * Compiler            : 
 * File Description    : 
 * Document Description: 
* Related Documents	   : 
* Note				   : 
* Programmer		   : RESTful MDE Engine created by Christoforos Zolotas
* Contact			   : christopherzolotas@issel.ee.auth.gr
*/


package eu.fp7.scase.wsat.outputmessage;


import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;
import javax.persistence.Table;
import javax.persistence.Transient;

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

import org.hibernate.Session;
import org.hibernate.annotations.ForeignKey;

import eu.fp7.scase.wsat.utilities.HypermediaLink;
import eu.fp7.scase.wsat.outputparameter.JavaoutputparameterModel;
import eu.fp7.scase.wsat.soapoperation.JavasoapoperationModel;


/* This class models the data of a outputmessage resource. It is enhanced with JAXB annotations for automated representation
parsing/marshalling as well as with Hibernate annotations for ORM transformations.*/
@XmlRootElement
@Entity
@Table(name="outputmessage")
public class JavaoutputmessageModel{


    /* There follows a list with the properties that model the outputmessage resource, as prescribed in the service CIM*/
		@Column(name = "name")
		private String name;

		@Id
		@GeneratedValue
		@Column(name = "outputmessageId")
		private int outputmessageId;

		// The Linklist property holds all the hypermedia links to be sent back to the client
		@Transient
		private List<HypermediaLink> linklist = new ArrayList<HypermediaLink>();

		// This property models the Many to One relationship between two resources as it is defined by the Hibernate syntax below.
		@ManyToOne(fetch = FetchType.EAGER)
		@JoinColumn(name="soapoperationId")
		@ForeignKey(name = "fk_soapoperation_outputmessage")
		private JavasoapoperationModel soapoperation;

		// This property models the One to Many relationship between two resources as it is defined by the Hibernate syntax below.
		@OneToMany(fetch = FetchType.EAGER, mappedBy="outputmessage",orphanRemoval=true)
		@OnDelete(action=OnDeleteAction.CASCADE)
		private Set<JavaoutputparameterModel> SetOfJavaoutputparameterModel = new HashSet<JavaoutputparameterModel>();

    /* There follows a list of setter and getter functions.*/
	    public void setname(String name){
        	this.name = name;
    	}

	    public void setoutputmessageId(int outputmessageId){
        	this.outputmessageId = outputmessageId;
    	}

	    public void setlinklist(List<HypermediaLink> linklist){
        	this.linklist = linklist;
    	}

		@XmlTransient
	    public void setsoapoperation(JavasoapoperationModel soapoperation){
        	this.soapoperation = soapoperation;
    	}

		@XmlTransient
	    public void setSetOfJavaoutputparameterModel(Set<JavaoutputparameterModel> SetOfJavaoutputparameterModel){
        	this.SetOfJavaoutputparameterModel = SetOfJavaoutputparameterModel;
    	}

	    public String getname(){
        	return this.name;
    	}

	    public int getoutputmessageId(){
        	return this.outputmessageId;
    	}

	    public List<HypermediaLink> getlinklist(){
        	return this.linklist;
    	}

	    public JavasoapoperationModel getsoapoperation(){
        	return this.soapoperation;
    	}

	    public Set<JavaoutputparameterModel> getSetOfJavaoutputparameterModel(){
        	return this.SetOfJavaoutputparameterModel;
    	}


    /* This function deletes explicitly any collections of this resource that are stored in the database 
    and iteratively does so for any subsequent related resources.
    NOTE: this function is needed to handle erroneous handling of cascade delete of some hibernate versions.*/
    public void deleteAllCollections(Session hibernateSession){


        Iterator<JavaoutputparameterModel> JavaoutputparameterModelIterator = SetOfJavaoutputparameterModel.iterator();
        while(JavaoutputparameterModelIterator.hasNext()){
            JavaoutputparameterModelIterator.next().deleteAllCollections(hibernateSession);
        }
    }
}
