/*
 * ARISTOSTLE UNIVERSITY OF THESSALONIKI
 * Copyright (C) 2015
 * Aristotle University of Thessaloniki
 * Department of Electrical & Computer Engineering
 * Division of Electronics & Computer Engineering
 * Intelligent Systems & Software Engineering Lab
 *
 * Project             : WSAT
 * WorkFile            : 
 * Compiler            : 
 * File Description    : 
 * Document Description: 
* Related Documents	   : 
* Note				   : 
* Programmer		   : RESTful MDE Engine created by Christoforos Zolotas
* Contact			   : christopherzolotas@issel.ee.auth.gr
*/


package eu.fp7.scase.wsat.outputparameter;


import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.DefaultValue;


/* This class defines the web API of the manager outputparameter resource. It handles POST and GET HTTP requests, as it is prescribed by the meta-models.*/
@Path("/multioutputparameterManager")
public class JavaoutputparameterControllerManager{

    @Context
    private UriInfo oApplicationUri;

	/* This function handles POST requests that are sent with any media type stated in the @Consumes JAX-RS annotation below 
     and returns any response in any media type stated in the @Produces JAX-RS annotation below.*/
	@Path("/outputmessage/{outputmessageId}/outputparameter/")
	@POST
	@Produces("application/JSON")
	@Consumes("application/JSON")
    public JavaoutputparameterModel postoutputmessageoutputparameter(@HeaderParam("authorization") String authHeader, @PathParam("outputmessageId")int outputmessageId, JavaoutputparameterModel oJavaoutputparameterModel){
        PostoutputmessageoutputparameterHandler oPostoutputmessageoutputparameterHandler = new PostoutputmessageoutputparameterHandler(authHeader, outputmessageId, oJavaoutputparameterModel, oApplicationUri);
        return oPostoutputmessageoutputparameterHandler.postJavaoutputparameterModel();
    }

	/* This function handles POST requests that are sent with any media type stated in the @Consumes JAX-RS annotation below 
     and returns any response in any media type stated in the @Produces JAX-RS annotation below.*/
	@Path("/outputparameter/{outputparameterId}/outputparameter/")
	@POST
	@Produces("application/JSON")
	@Consumes("application/JSON")
    public JavaoutputparameterModel postoutputparameteroutputparameter(@HeaderParam("authorization") String authHeader, @PathParam("outputparameterId")int outputparameterId, JavaoutputparameterModel oJavaoutputparameterModel){
        PostoutputparameteroutputparameterHandler oPostoutputparameteroutputparameterHandler = new PostoutputparameteroutputparameterHandler(authHeader, outputparameterId, oJavaoutputparameterModel, oApplicationUri);
        return oPostoutputparameteroutputparameterHandler.postJavaoutputparameterModel();
    }

    /* This function handles GET requests  
     and returns any response in any media type stated in the @Produces JAX-RS annotation below.*/
	@Path("/outputmessage/{outputmessageId}/outputparameter/")
	@GET
	@Produces("application/JSON")
    public JavaoutputparameterModelManager getoutputmessageoutputparameterList(@HeaderParam("authorization") String authHeader, @PathParam("outputmessageId")int outputmessageId){
        GetoutputmessageoutputparameterListHandler oGetoutputmessageoutputparameterListHandler = new GetoutputmessageoutputparameterListHandler(authHeader, outputmessageId, oApplicationUri);
        return oGetoutputmessageoutputparameterListHandler.getJavaoutputparameterModelManager();
    }

    /* This function handles GET requests  
     and returns any response in any media type stated in the @Produces JAX-RS annotation below.*/
	@Path("/outputparameter/{outputparameterId}/outputparameter/")
	@GET
	@Produces("application/JSON")
    public JavaoutputparameterModelManager getoutputparameteroutputparameterList(@HeaderParam("authorization") String authHeader, @PathParam("outputparameterId")int outputparameterId){
        GetoutputparameteroutputparameterListHandler oGetoutputparameteroutputparameterListHandler = new GetoutputparameteroutputparameterListHandler(authHeader, outputparameterId, oApplicationUri);
        return oGetoutputparameteroutputparameterListHandler.getJavaoutputparameterModelManager();
    }

}
